<template>
    <f7-page 
        name="scan" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut">

        <!-- Top Navbar -->
		<f7-navbar :sliding="false">
            <f7-nav-title>Scan Code</f7-nav-title>
		</f7-navbar>
        <f7-icon class="target" material="crop_free" size="450" color="white"></f7-icon>
        <f7-link @click="handleFlash" class="flash"><f7-icon :material="`flash_${scannerStatus != null && scannerStatus.lightEnabled ? 'on' : 'off'}`"></f7-icon></f7-link>
        <f7-link @click="handleStartScan" class="start"><f7-icon material="center_focus_strong" :color="scannerStatus != null && scannerStatus.previewing ? 'red' : 'white'"></f7-icon></f7-link>
        <f7-link @click="handleCamera" class="flip">
            <f7-icon v-if="scannerStatus != null && scannerStatus.currentCamera == 0" material="switch_camera"></f7-icon>
            <f7-icon v-else material="camera_front"></f7-icon>
        </f7-link>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, dateFormat, convertAmpersand, bytesToSize } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Scan',
    data(){
        return {
            scannerStatus: null
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('document', ['document'])
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
    },
    methods: {
        dateFormat,
        convertAmpersand,
        bytesToSize,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            QRScanner.getStatus(function(status){
				if(!status.authorized && status.canOpenSettings){
					app.dialog.confirm("Would you like to enable QR code scanning? You can allow camera access in your settings.", "Doctrin", function(){
						QRScanner.openSettings();
					});
				}else{
					QRScanner.show(function(status){
						self.scannerStatus = status;
					});
				}
			});
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;
            
            QRScanner.destroy(function(status){
				self.scannerStatus = null;
			});
        },
        handleCamera(){
			const self = this;
			const app = self.$f7;

			QRScanner.getStatus(function(status){
				if(status.canChangeCamera){
					if(status.lightEnabled){
						QRScanner.disableLight(function(err, status){
							if(err){
								app.dialog.alert(err._message, 'Doctrin');
							}
							self.scannerStatus = status;
						});
					}else{
						QRScanner.enableLight(function(err, status){
							if(err){
								app.dialog.alert(err._message, 'Doctrin');
							}
							self.scannerStatus = status;
						});
					}
				}				
			});
		},
		handleFlash(){
			const self = this;
			const app = self.$f7;

			QRScanner.getStatus(function(status){
				if(status.lightEnabled){
					QRScanner.disableLight(function(err, status){
						if(err){
							app.dialog.alert(err._message, 'Doctrin');
						}
						self.scannerStatus = status;
					});
				}else{
					QRScanner.enableLight(function(err, status){
						if(err){
							app.dialog.alert(err._message, 'Doctrin');
						}
						self.scannerStatus = status;
					});
				}
			});
		},
		handleStartScan(){
			const self = this;
			const app = self.$f7;

			QRScanner.getStatus(function(status){
				if(status.previewing){
					QRScanner.pausePreview(function(status){
						self.scannerStatus = status;
					});
				}else{
					QRScanner.scan(function(err, contents){
						if(err){
							app.dialog.alert(err._message, 'Doctrin');
						}else{
							self.doTracking(contents);
						}
					});
				}
			});			
		},
		doTracking(trackingNumber){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.preloader.show('red');

			self.$store.dispatch('document/trackDocument', {
				tracking_number: trackingNumber
			}).then(()=>{
                setTimeout(()=>{
                    app.preloader.hide();
                    self.$f7router.navigate('/document/'+self.document.id+'/status/');
                }, 100);
			});
        },	
        
    },

}
</script>
<style lang="scss" scoped>
    div[data-name="scan"]{

        a{
            position: absolute;
            .icon{
                font-size: 32px;
                color: #fff;
            }
        }

        .target{
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -70%);
            color: #fff;
        }

        .flash{
            bottom: 150px;
            left: 50px;
        }

        .start{
            bottom: 150px;
            left: 50%;
            transform: translate(-50%);
            .icon{
                font-size: 40px;	
            }
        }

        .flip{
            bottom: 150px;
            right: 50px;
        }
    }
</style>